import { OnDestroy, EventEmitter, AfterViewInit } from '@angular/core';
/**
 * CodeMirror component
 * Usage :
 * <lt-codemirror [(ngModel)]="data" [config]="{...}"></lt-codemirror>
 */
export declare class LtCodemirrorComponent implements AfterViewInit, OnDestroy {
    config: any;
    size: {
        w: string | number;
        h: string | number;
    };
    change: EventEmitter<{}>;
    focus: EventEmitter<{}>;
    blur: EventEmitter<{}>;
    cursorActivity: EventEmitter<{}>;
    host: any;
    instance: any;
    _value: string;
    /**
     * Constructor
     */
    constructor();
    value: string;
    /**
     * On component destroy
     */
    ngOnDestroy(): void;
    /**
     * On component view init
     */
    ngAfterViewInit(): void;
    /**
     * Initialize codemirror
     */
    codemirrorInit(config: any, size: any): void;
    /**
     * Value update process
     */
    updateValue(value: any): void;
    /**
     * Implements ControlValueAccessor
     */
    writeValue(value: any): void;
    onChange(_: any): void;
    onTouched(): void;
    registerOnChange(fn: any): void;
    registerOnTouched(fn: any): void;
}
